"use strict";

var _Object$defineProperty = require("babel-runtime/core-js/object/define-property")["default"];

_Object$defineProperty(exports, "__esModule", {
    value: true
});

exports.xor = xor;
/**
 * Returns true if one and only one of the conditions is true.
 *
 * @this {boolean} Left boolean operand.
 * @param right Right boolean operand.
 * @example Basic Usage
 *
 * ```javascript
 * true::and(true) // false
 * true::and(false) // true
 * false::and(true) // true
 * false::and(false) // false
 * ```
*/

function xor(right) {
    return Boolean(Number(this) ^ Number(right));
}

;