"use strict";

var _regeneratorRuntime = require("babel-runtime/regenerator")["default"];

var _Object$defineProperty = require("babel-runtime/core-js/object/define-property")["default"];

var _getIterator = require("babel-runtime/core-js/get-iterator")["default"];

_Object$defineProperty(exports, "__esModule", {
    value: true
});

exports.intersection = intersection;
var marked0$0 = [intersection].map(_regeneratorRuntime.mark);
/**
 * Yields the sorted intersection iterator of two sorted iterators.
 *
 * @this {Iterable<T>}
 * @param comparator The sorting value function. Should return `0` when items are equal, a positive number when the item on the left is greater and a negative number when the item on the right is greater.
 * @ntime O(n+m)
 * @dspace O(2)
 * @example Basic Usage
 *
 * ```javascript
 * [1,2,3,4,5]::intersection([2,3,4,6], function (b) {
 *   return this - b;
 * }); // yields 2,3,4
 * ```
*/

function intersection(b, comparator) {
    var iteratorA, iteratorB, stepA, stepB, _context, comparison;

    return _regeneratorRuntime.wrap(function intersection$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                iteratorA = _getIterator(this);
                iteratorB = _getIterator(b);
                stepA = iteratorA.next();
                stepB = iteratorB.next();

            case 4:
                if (!(!stepA.done && !stepB.done)) {
                    context$1$0.next = 20;
                    break;
                }

                comparison = (_context = stepA.value, comparator).call(_context, stepB.value);

                if (!(comparison < 0)) {
                    context$1$0.next = 10;
                    break;
                }

                stepA = iteratorA.next();
                context$1$0.next = 18;
                break;

            case 10:
                if (!(comparison > 0)) {
                    context$1$0.next = 14;
                    break;
                }

                stepB = iteratorB.next();
                context$1$0.next = 18;
                break;

            case 14:
                context$1$0.next = 16;
                return stepA.value;

            case 16:
                stepA = iteratorA.next();
                stepB = iteratorB.next();

            case 18:
                context$1$0.next = 4;
                break;

            case 20:
            case "end":
                return context$1$0.stop();
        }
    }, marked0$0[0], this);
}

;